<template>
  <b-overlay :show="overlayAccess" rounded="sm" variant="primary" spinner-type="" opacity="0.1" blur="2px">
    <b-overlay :show="overlay" rounded="sm" variant="primary" opacity="0.4" blur="2px">
      <ValidationObserver v-slot="{ invalid }">
        <div class="card-body">
          <div class="col-12">
            <div v-for="(object,index) in jobs" v-bind:key="index">
              <b-row class="form-group mt-10">
                <b-col md="3">
                  <div class="form-group">
                    <label class="col-form-label text-lg-right text-left">
                      عنوان شغلی(سمت)
                      <span class="text-danger">*</span>
                    </label>
                    <div class="custom-file">
                      <ValidationProvider rules="required|min:3" v-slot="{ errors }">
                        <input
                            type="text"
                            class="form-control"
                            placeholder="مثلا : برنامه نویس"
                            v-model="object.name"
                            name="عنوان شغلی(سمت)"
                        />
                        <span class="text-danger">{{ errors[0] }}</span>
                      </ValidationProvider>
                    </div>
                  </div>
                </b-col>

                <b-col md="3">
                  <div class="form-group">
                    <label class="col-form-label text-lg-right text-left">
                      نام شرکت
                      <span class="text-danger">*</span>
                    </label>
                    <div class="custom-file">
                      <ValidationProvider rules="required|min:3" v-slot="{ errors }">
                        <input
                            type="text"
                            class="form-control"
                            placeholder="مثلا : شرکت ذهن افزار سورنا"
                            v-model="object.location"
                            name="نام شرکت"
                        />
                        <span class="text-danger">{{ errors[0] }}</span>
                      </ValidationProvider>
                    </div>
                  </div>
                </b-col>

                <b-col md="2">
                  <div class="form-group">
                    <label class="col-form-label text-lg-right text-left">
                      تاریخ شروع به کار
                      <span class="text-danger">*</span>
                    </label>
                    <div class="custom-file">
                      <ValidationProvider rules="required|min:3" v-slot="{ errors }">
                        <date-picker
                            v-model="object.endDate"
                            :auto-submit="true"
                            format="YYYY-MM-DD HH:mm:ss"
                            display-format="dddd jDD jMMMM jYYYY"
                            placeholder="مثلا : 1376/04/19"
                        />
                        <span class="text-danger">{{ errors[0] }}</span>
                      </ValidationProvider>
                    </div>
                  </div>
                </b-col>
                <b-col md="2">
                  <div class="form-group">
                    <label class="col-form-label text-lg-right text-left">
                      تاریخ پایان همکاری
                      <span class="text-danger">*</span>
                    </label>
                    <div class="custom-file">
                      <ValidationProvider rules="required|min:3" v-slot="{ errors }">
                        <date-picker
                            v-model="object.startDate"
                            :auto-submit="true"
                            format="YYYY-MM-DD HH:mm:ss"
                            display-format="dddd jDD jMMMM jYYYY"
                            placeholder="مثلا : 1376/04/19"
                        />
                        <span class="text-danger">{{ errors[0] }}</span>
                      </ValidationProvider>
                    </div>
                  </div>
                </b-col>

                <b-col md="2" class="mt-10">
                  <b-button class="btn btn-danger col-12" @click="deleteItem(index)">حذف</b-button>
                </b-col>
              </b-row>
              <div class="separator separator-solid separator-border-2 separator-success my-8"></div>
            </div>
          </div>

          <div v-if="jobs.length<1" class="col-md-12 mx-auto my-10">
            <div class="alert alert-custom alert-notice alert-light-info fade show" role="alert">
              <div class="alert-icon">
                <i class="flaticon-medal"></i>
              </div>
              <div class="alert-text text-black-50 mx-4">
                <b>مهارت های ویژه |</b>هیچ اطلاعاتی ثبت نشده است، برای ثبت اطلاعات بر روی "افزودن مهارت های ویژه" کلیک
                کنید.
              </div>
            </div>
          </div>
          <button type="button" class="btn btn-primary col-3" @click="additem">افزودن موقعیت های شغلی</button>
          <div class="col-12">
            <div v-for="(object,index) in languages" v-bind:key="index">
              <b-row class="form-group mt-10">
                <b-col md="3">
                  <div class="form-group">
                    <label class="col-form-label text-lg-right text-left">
                      نام زبان
                      <span class="text-danger">*</span>
                    </label>
                    <div class="custom-file">
                      <ValidationProvider rules="required|min:3" v-slot="{ errors }">
                        <input
                            type="text"
                            class="form-control"
                            placeholder="مثلا : انگلیسی"
                            v-model="object.name"
                            name="نام زبان"
                        />
                        <span class="text-danger">{{ errors[0] }}</span>
                      </ValidationProvider>
                    </div>
                  </div>
                </b-col>

                <b-col md="3">
                  <div class="form-group">
                    <label class="col-form-label text-lg-right text-left">
                      سطح تسلط
                      <span class="text-danger">*</span>
                    </label>
                    <ValidationProvider rules="required" v-slot="{ errors }">
                      <select class="form-control" v-model="object.ability" name="سطح تسلط">
                        <option value="پایان خدمت">مبتدی</option>
                        <option value="معافیت دائم">متوسط</option>
                        <option value="معافیت تحصیلی">حرفه ای</option>
                        <option value="در حال انجام">مادرزاد</option>
                      </select>
                      <span class="text-danger">{{ errors[0] }}</span>
                    </ValidationProvider>
                  </div>
                </b-col>

                <b-col md="2" class="mt-10">
                  <b-button class="btn btn-danger col-12" @click="deleteLangItem(index)">حذف</b-button>
                </b-col>
              </b-row>
              <div class="separator separator-solid separator-border-2 separator-success my-8"></div>
            </div>
          </div>

          <div v-if="languages.length<1" class="col-md-12 mx-auto my-10">
            <div class="alert alert-custom alert-notice alert-light-info fade show" role="alert">
              <div class="alert-icon">
                <i class="flaticon-medal"></i>
              </div>
              <div class="alert-text text-black-50 mx-4">
                <b>افزودن زبان |</b>هیچ اطلاعاتی ثبت نشده است، برای ثبت اطلاعات بر روی "افزودن زبان" کلیک
                کنید.
              </div>
            </div>
          </div>
          <button type="button" class="btn btn-primary col-3" @click="addLangItem">افزودن زبان</button>
          <div class="col-md-12 mt-20">
            <div class="d-flex flex-column text-md-center">
            <span id="disabled-wrapper" tabindex="-5">
              <button
                  v-if="invalid || overlayAccess"
                  type="button"
                  :disabled="true"
                  class="btn btn-success btn-lg btn-block"
              >ذخیره اطلاعات</button>
              <button
                  v-else
                  @click="checkJobAndLang()"
                  type="button"
                  class="btn btn-success btn-lg btn-block"
              >ذخیره اطلاعات</button>
            </span>
              <b-tooltip
                  v-if="invalid"
                  class="font-family: IRANYekan !important"
                  target="disabled-wrapper"
              >تا زمانی که همه ی فیلد ها تکمیل نشوند این دکمه فعال نمی شود
              </b-tooltip>
            </div>
          </div>
        </div>
      </ValidationObserver>
    </b-overlay>
  </b-overlay>
</template>

<script>
import {ValidationObserver, ValidationProvider} from "vee-validate";
import gql from "graphql-tag";
import jobsAndLanguagesInformation from "~/apollo/mutation/resume/jobsAndLanguagesInformation.gql";

export default {
  props: ["option"],
  name: "JobsLanguages.vue",
  components: {
    ValidationObserver,
    ValidationProvider,
    DatePicker: () => import("vue-persian-datetime-picker"),
  },
  data() {
    return {
      jobs: [],
      languages: [],
      errors: null,
      invalid: null,
      now: Date.now(),
      overlay: false,
      overlayAccess: false,
    };
  },
  async mounted() {
    if (this.option) {
      if (this.option.ConfirmationStatus !== "Filling") {
        this.overlayAccess = true;
      }
      this.jobs = this.option.jobs;
      this.languages = this.option.languages;
    }
  },

  methods: {
    additem() {
      let myObject = {
        name: "",
        location: "",
        startDate: "",
        endDate: "",
      };
      this.jobs.push(myObject);
    },
    deleteItem(index) {
      Swal.fire({
        title: "حذف مهارت",
        text: "ایا از حذف این مهارت اطمینان دارید؟",
        icon: "warning",
        confirmButtonText: "باشه",
        cancelButtonText: "انصراف",
        showCancelButton: true,
      }).then((res) => {
        res.isConfirmed ? this.jobs.splice(index, 1) : "";
      });
    },
    addLangItem() {
      let myObject = {
        name: "",
        ability: "",
      };
      this.languages.push(myObject);
    },
    deleteLangItem(index) {
      Swal.fire({
        title: "حذف مهارت",
        text: "ایا از حذف این مهارت اطمینان دارید؟",
        icon: "warning",
        confirmButtonText: "باشه",
        cancelButtonText: "انصراف",
        showCancelButton: true,
      }).then((res) => {
        res.isConfirmed ? this.languages.splice(index, 1) : "";
      });
    },
    alert(title, text, icon) {
      Swal.fire({
        title: title,
        text: text,
        icon: icon,
        confirmButtonText: "باشه",
      });
    },
    checkJobAndLang() {
      let self = this;
      if (this.jobs.length < 1) {
        this.jobFirstSwal();
      } else if (this.languages.length < 1) {
        this.langFirstSwal();
      } else {
        this.saveJobAndLang();
      }
    },
    jobFirstSwal() {
      Swal.fire({
        title: "عدم ثبت اطلاعات",
        text: "هیچ موقعیت شغلی ثبت نشده است،ادامه می دهید؟",
        icon: "warning",
        confirmButtonText: "آره!",
        cancelButtonText: "انصراف",
        showCancelButton: true,
      }).then((res) => {
        if (this.languages.length == 0) {
          if (res.isConfirmed) {
            Swal.fire({
              title: "عدم ثبت اطلاعات",
              text: "هیچ زبانی ثبت نشده است،ادامه می دهید؟",
              icon: "warning",
              confirmButtonText: "بله، اطلاعات ثبت شود",
              cancelButtonText: "انصراف",
              showCancelButton: true,
            }).then((res) => {
              if (res.isConfirmed) this.saveJobAndLang();
            });
          }
        } else {
          if (res.isConfirmed) this.saveJobAndLang();
        }
      });
    },
    langFirstSwal() {
      Swal.fire({
        title: "عدم ثبت اطلاعات",
        text: "هیچ زبانی ثبت نشده است،ادامه می دهید؟",
        icon: "warning",
        confirmButtonText: "آره!",
        cancelButtonText: "انصراف",
        showCancelButton: true,
      }).then((res) => {
        if (this.jobs.length == 0) {
          if (res.isConfirmed) {
            Swal.fire({
              title: "عدم ثبت اطلاعات",
              text: "هیچ موقعیت شغلی ثبت نشده است،ادامه می دهید؟",
              icon: "warning",
              confirmButtonText: "بله، اطلاعات ثبت شود",
              cancelButtonText: "انصراف",
              showCancelButton: true,
            }).then((res) => {
              if (res.isConfirmed) this.saveJobAndLang();
            });
          }
        } else {
          if (res.isConfirmed) this.saveJobAndLang();
        }
      });
    },

    async saveJobAndLang() {
      let self = this;
      self.overlay = true;
      let variables = {
        id: this.option.id,
        jobs: JSON.stringify(self.jobs),
        languages: JSON.stringify(self.languages),
      };
      let mutation = gql`
        ${jobsAndLanguagesInformation}
      `;
      await this.$apollo
          .mutate({
            mutation,
            variables,
            context: {headers: {"x-token": this.$auth.getToken("local")}},
          })
          .then(({data}) => {
            self.overlay = false;
            Swal.close();
            if (data.jobsAndLanguagesInformation != null) {
              Swal.fire({
                title: "موفقیت آمیز",
                text: "اطلاعات با موفقیت ثبت شد.",
                icon: "success",
                confirmButtonText: "باشه",
              }).then((res) => {
                this.$emit("my-event", {
                  step: "JobsLanguages",
                  jobs: self.jobs,
                  languages: self.languages,
                });
              });
            }
          })
          .catch((err) => {
            self.overlay = false;
            Swal.close();
            let gqlError = err.graphQLErrors;
            if (gqlError.length > 0) {
              if (err.graphQLErrors[0].extensions.code == "UNAUTHENTICATED") {
                let self = this;
                console.log("please login");
                /* this.$auth.logout().then(res => {
                       self.$router.push("/login");
                     });*/
              }
            } else {
              Swal.fire({
                title: "خطا",
                text:
                    "مشکل در ارتباط، لطفا اتصال اینترنت خود را بررسی و سپس مجددا تلاش کنید",
                icon: "error",
                confirmButtonText: "باشه",
              });
            }
          });
    },
  },
};
</script>

<style scoped>
</style>